// # means that we are referring to the pre-compiler
#include <iostream> // external libraries
#include <math.h>
#include "Vector.h" // internal libraries
#include "Scalar.h"
#include "Sphere.h"

int unitTest()
{
	Vector v;
	v.x = 4;
	v.x = -5;
	v.x = 0.5f;

	Vector w = Vector(1, 2, 3);
	Vector u(4, 5, 6);

	Vector r;
	r.sum(w, u);
	r.print();

	return 0;
}

bool unitTestForCrossAndDot()
{
	Vector a(3, -3, 2);
	Vector b(0.5, -1, 6);

	Vector c = cross(a, b);
	Scalar k0 = dot(a, c);
	Scalar k1 = dot(b, c);

	std::cout << k0 << ", " << k1 << std::endl;

	// return (k0 == 0) && (k1 == 0); could be slightly different
	return isZero(k0) && isZero(k1);
}

bool unitTestShpereRay()
{
	Sphere s;
	s.center = Vector(5, 5, 5);
	s.radius = 5;

	Ray r;
	r.position = Vector(-222, 2, 2);
	r.direction = Vector(-1, -1, -1) * (1 / sqrt(3)); // normalized

	Vector hitPoint = Hit(s, r);
	hitPoint.print();

	std::cout << dist(hitPoint, s.center) << std::endl;

	return true;
}

int main()
{
	unitTestShpereRay();
}