#include <math.h>
#include "Sphere.h"

Vector Hit(Sphere sphere, Ray ray)
{
	Vector C = sphere.center;
	Scalar r = sphere.radius;
	Vector d = ray.direction;
	Vector H = ray.position;

	const Scalar a = 1;
	const Scalar b = 2 * dot((H - C), d);
	const Scalar c = dot(H - C, H - C) - r * r; // ||H-C||^2-r^2

	// first hit -> - // second hit -> +
	const Scalar delta = b * b - 4 * a * c;

	if (delta < 0)
		return NO_HIT;

	Scalar k = (-b - sqrt(delta)) / (2 * a);
	
	if (k < 0)
		return NO_HIT;

	return H + k * d;
}