#include <iostream>
#include <math.h>
#include "Vector.h"

Vector cross(const Vector& a, const Vector& b)
{
	return Vector(
		a.y * b.z - a.z * b.y,
		a.z * b.x - a.x * b.z,
		a.x * b.y - a.y * b.x);
}

Scalar dot(const Vector& a, const Vector& b)
{
	return a.x * b.x + a.y * b.y + a.z * b.z;
}

Scalar norm(const Vector& v)
{
	return sqrt(dot(v, v));
}

Scalar dist(const Vector& a, const Vector& b)
{
	return norm(a - b);
}

void Vector::print() const
{
	std::cout << "(" << x << ", " << y << ", " << z << ")" << std::endl;
}
